package PolíticasDeDesenvolvimento;

public abstract aspect PrivacidadeRestrita {
	protected pointcut classesAfectadas(Object alvo) : target(alvo);
		
	private pointcut acessoAMétodos() : 
		call(!static private * *.*(..)) || call(!static protected * *.*(..)) ||
		call(!static private *.new(..)) || call(!static protected *.new(..));
	
	private pointcut acessoAAtributos() : 
		set(!static private * *.*) || get(!static private * *.*) ||
		set(!static protected * *.*) || get(!static protected * *.*);

	private pointcut acessoNãoEstático(Object acedente, Object acedido) :
		(acessoAAtributos() || acessoAMétodos()) && 
		this(acedente) && target(acedido) &&
		if(acedente != acedido);

	before(Object acedente, Object acedido) : 
		acessoNãoEstático(acedente, acedido) &&	classesAfectadas(Object) {
		throw new AcessoIlegal(thisJoinPointStaticPart.toString());
	}
	
	private pointcut acessoEstático() :
		(acessoAMétodos() || acessoAAtributos()) &&
		withincode(static * *.*(..));

	before(Object alvo) : 
		acessoEstático() && classesAfectadas(alvo) {
		throw new AcessoIlegal(thisJoinPointStaticPart.toString());
	}
}
