package PolíticasDeDesenvolvimento;

public aspect VerificaçãoDeInvariante {
	private static boolean show = true;
	    
	pointcut verificavel() : within(InvarianteVerificável+ && !InvarianteVerificável) &&
							 !cflow(within(VerificaçãoDeInvariante));
	
	pointcut construtores(): verificavel() &&
		(execution(public (InvarianteVerificável+ && !InvarianteVerificável).new(..)) || 
		 execution(protected (InvarianteVerificável+ && !InvarianteVerificável).new(..)));
        
	pointcut destrutor(): verificavel() && 
		execution(void finalize());

    pointcut métodosNãoPrivados(): verificavel() &&
    (execution(public * *(..)) || execution(protected * *(..)));

	pointcut métodosNãoPrivadosNãoEstáticos(): verificavel() && 
    	métodosNãoPrivados() && execution(!static * *(..));
	
    before(final InvarianteVerificável o): target(o) && 
	    métodosNãoPrivadosNãoEstáticos() && !destrutor() && !execution(boolean cumpreInvariante()) { 
    	if(show) 
			System.out.println("Antes de método: " + thisJoinPoint);
	    assert o.cumpreInvariante() : "Antes de método: " + thisJoinPoint;
    }
    
    before(final InvarianteVerificável o): target(o) && destrutor() { 
		if(show) 
			System.out.println("Antes de destrutor " + thisJoinPoint);
        org.aspectj.lang.reflect.SourceLocation location = 
            thisJoinPointStaticPart.getSourceLocation();
        if(!o.cumpreInvariante())
            System.out.println(location.getFileName() + ":" + location.getLine() + 
							   " invariante inválido em " + thisJoinPoint);
    }

    after(final InvarianteVerificável o): target(o) && !destrutor() && 
	    (métodosNãoPrivadosNãoEstáticos() || construtores()) &&
	    !execution(boolean cumpreInvariante()) { 
		if(show) 
			System.out.println("Depois de método ou construtor " + thisJoinPoint);
        org.aspectj.lang.reflect.SourceLocation location = 
            thisJoinPointStaticPart.getSourceLocation();
		assert o.cumpreInvariante() : location.getFileName() + ":" + location.getLine() + 
		   " invariante inválido em " + thisJoinPoint;
    }
}
